git-commit.shon commit Update draft release notes for 1.5.4 (1c46ab1)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4# Copyright (c) 2006 Junio C Hamano
   5
   6USAGE='[-a | --interactive] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit> | --amend] [-u] [-e] [--author <author>] [--template <file>] [[-i | -o] <path>...]'
   7SUBDIRECTORY_OK=Yes
   8OPTIONS_SPEC=
   9. git-sh-setup
  10require_work_tree
  11
  12git rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
  13
  14case "$0" in
  15*status)
  16        status_only=t
  17        ;;
  18*commit)
  19        status_only=
  20        ;;
  21esac
  22
  23refuse_partial () {
  24        echo >&2 "$1"
  25        echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
  26        exit 1
  27}
  28
  29TMP_INDEX=
  30THIS_INDEX="${GIT_INDEX_FILE:-$GIT_DIR/index}"
  31NEXT_INDEX="$GIT_DIR/next-index$$"
  32rm -f "$NEXT_INDEX"
  33save_index () {
  34        cp -p "$THIS_INDEX" "$NEXT_INDEX"
  35}
  36
  37run_status () {
  38        # If TMP_INDEX is defined, that means we are doing
  39        # "--only" partial commit, and that index file is used
  40        # to build the tree for the commit.  Otherwise, if
  41        # NEXT_INDEX exists, that is the index file used to
  42        # make the commit.  Otherwise we are using as-is commit
  43        # so the regular index file is what we use to compare.
  44        if test '' != "$TMP_INDEX"
  45        then
  46                GIT_INDEX_FILE="$TMP_INDEX"
  47                export GIT_INDEX_FILE
  48        elif test -f "$NEXT_INDEX"
  49        then
  50                GIT_INDEX_FILE="$NEXT_INDEX"
  51                export GIT_INDEX_FILE
  52        fi
  53
  54        if test "$status_only" = "t" -o "$use_status_color" = "t"; then
  55                color=
  56        else
  57                color=--nocolor
  58        fi
  59        git runstatus ${color} \
  60                ${verbose:+--verbose} \
  61                ${amend:+--amend} \
  62                ${untracked_files:+--untracked}
  63}
  64
  65trap '
  66        test -z "$TMP_INDEX" || {
  67                test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
  68        }
  69        rm -f "$NEXT_INDEX"
  70' 0
  71
  72################################################################
  73# Command line argument parsing and sanity checking
  74
  75all=
  76also=
  77interactive=
  78only=
  79logfile=
  80use_commit=
  81amend=
  82edit_flag=
  83no_edit=
  84log_given=
  85log_message=
  86verify=t
  87quiet=
  88verbose=
  89signoff=
  90force_author=
  91only_include_assumed=
  92untracked_files=
  93templatefile="`git config commit.template`"
  94while test $# != 0
  95do
  96        case "$1" in
  97        -F|--F|-f|--f|--fi|--fil|--file)
  98                case "$#" in 1) usage ;; esac
  99                shift
 100                no_edit=t
 101                log_given=t$log_given
 102                logfile="$1"
 103                ;;
 104        -F*|-f*)
 105                no_edit=t
 106                log_given=t$log_given
 107                logfile="${1#-[Ff]}"
 108                ;;
 109        --F=*|--f=*|--fi=*|--fil=*|--file=*)
 110                no_edit=t
 111                log_given=t$log_given
 112                logfile="${1#*=}"
 113                ;;
 114        -a|--a|--al|--all)
 115                all=t
 116                ;;
 117        --au=*|--aut=*|--auth=*|--autho=*|--author=*)
 118                force_author="${1#*=}"
 119                ;;
 120        --au|--aut|--auth|--autho|--author)
 121                case "$#" in 1) usage ;; esac
 122                shift
 123                force_author="$1"
 124                ;;
 125        -e|--e|--ed|--edi|--edit)
 126                edit_flag=t
 127                ;;
 128        -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
 129                also=t
 130                ;;
 131        --int|--inte|--inter|--intera|--interac|--interact|--interacti|\
 132        --interactiv|--interactive)
 133                interactive=t
 134                ;;
 135        -o|--o|--on|--onl|--only)
 136                only=t
 137                ;;
 138        -m|--m|--me|--mes|--mess|--messa|--messag|--message)
 139                case "$#" in 1) usage ;; esac
 140                shift
 141                log_given=m$log_given
 142                log_message="${log_message:+${log_message}
 143
 144}$1"
 145                no_edit=t
 146                ;;
 147        -m*)
 148                log_given=m$log_given
 149                log_message="${log_message:+${log_message}
 150
 151}${1#-m}"
 152                no_edit=t
 153                ;;
 154        --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
 155                log_given=m$log_given
 156                log_message="${log_message:+${log_message}
 157
 158}${1#*=}"
 159                no_edit=t
 160                ;;
 161        -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|\
 162        --no-verify)
 163                verify=
 164                ;;
 165        --a|--am|--ame|--amen|--amend)
 166                amend=t
 167                use_commit=HEAD
 168                ;;
 169        -c)
 170                case "$#" in 1) usage ;; esac
 171                shift
 172                log_given=t$log_given
 173                use_commit="$1"
 174                no_edit=
 175                ;;
 176        --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
 177        --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
 178        --reedit-messag=*|--reedit-message=*)
 179                log_given=t$log_given
 180                use_commit="${1#*=}"
 181                no_edit=
 182                ;;
 183        --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
 184        --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|\
 185        --reedit-message)
 186                case "$#" in 1) usage ;; esac
 187                shift
 188                log_given=t$log_given
 189                use_commit="$1"
 190                no_edit=
 191                ;;
 192        -C)
 193                case "$#" in 1) usage ;; esac
 194                shift
 195                log_given=t$log_given
 196                use_commit="$1"
 197                no_edit=t
 198                ;;
 199        --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
 200        --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
 201        --reuse-message=*)
 202                log_given=t$log_given
 203                use_commit="${1#*=}"
 204                no_edit=t
 205                ;;
 206        --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
 207        --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
 208                case "$#" in 1) usage ;; esac
 209                shift
 210                log_given=t$log_given
 211                use_commit="$1"
 212                no_edit=t
 213                ;;
 214        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 215                signoff=t
 216                ;;
 217        -t|--t|--te|--tem|--temp|--templ|--templa|--templat|--template)
 218                case "$#" in 1) usage ;; esac
 219                shift
 220                templatefile="$1"
 221                no_edit=
 222                ;;
 223        -q|--q|--qu|--qui|--quie|--quiet)
 224                quiet=t
 225                ;;
 226        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 227                verbose=t
 228                ;;
 229        -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|\
 230        --untracked|--untracked-|--untracked-f|--untracked-fi|--untracked-fil|\
 231        --untracked-file|--untracked-files)
 232                untracked_files=t
 233                ;;
 234        --)
 235                shift
 236                break
 237                ;;
 238        -*)
 239                usage
 240                ;;
 241        *)
 242                break
 243                ;;
 244        esac
 245        shift
 246done
 247case "$edit_flag" in t) no_edit= ;; esac
 248
 249################################################################
 250# Sanity check options
 251
 252case "$amend,$initial_commit" in
 253t,t)
 254        die "You do not have anything to amend." ;;
 255t,)
 256        if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 257                die "You are in the middle of a merge -- cannot amend."
 258        fi ;;
 259esac
 260
 261case "$log_given" in
 262tt*)
 263        die "Only one of -c/-C/-F can be used." ;;
 264*tm*|*mt*)
 265        die "Option -m cannot be combined with -c/-C/-F." ;;
 266esac
 267
 268case "$#,$also,$only,$amend" in
 269*,t,t,*)
 270        die "Only one of --include/--only can be used." ;;
 2710,t,,* | 0,,t,)
 272        die "No paths with --include/--only does not make sense." ;;
 2730,,t,t)
 274        only_include_assumed="# Clever... amending the last one with dirty index." ;;
 2750,,,*)
 276        ;;
 277*,,,*)
 278        only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
 279        also=
 280        ;;
 281esac
 282unset only
 283case "$all,$interactive,$also,$#" in
 284*t,*t,*)
 285        die "Cannot use -a, --interactive or -i at the same time." ;;
 286t,,,[1-9]*)
 287        die "Paths with -a does not make sense." ;;
 288,t,,[1-9]*)
 289        die "Paths with --interactive does not make sense." ;;
 290,,t,0)
 291        die "No paths with -i does not make sense." ;;
 292esac
 293
 294if test ! -z "$templatefile" -a -z "$log_given"
 295then
 296        if test ! -f "$templatefile"
 297        then
 298                die "Commit template file does not exist."
 299        fi
 300fi
 301
 302################################################################
 303# Prepare index to have a tree to be committed
 304
 305case "$all,$also" in
 306t,)
 307        if test ! -f "$THIS_INDEX"
 308        then
 309                die 'nothing to commit (use "git add file1 file2" to include for commit)'
 310        fi
 311        save_index &&
 312        (
 313                cd_to_toplevel &&
 314                GIT_INDEX_FILE="$NEXT_INDEX" &&
 315                export GIT_INDEX_FILE &&
 316                git diff-files --name-only -z |
 317                git update-index --remove -z --stdin
 318        ) || exit
 319        ;;
 320,t)
 321        save_index &&
 322        git ls-files --error-unmatch -- "$@" >/dev/null || exit
 323
 324        git diff-files --name-only -z -- "$@"  |
 325        (
 326                cd_to_toplevel &&
 327                GIT_INDEX_FILE="$NEXT_INDEX" &&
 328                export GIT_INDEX_FILE &&
 329                git update-index --remove -z --stdin
 330        ) || exit
 331        ;;
 332,)
 333        if test "$interactive" = t; then
 334                git add --interactive || exit
 335        fi
 336        case "$#" in
 337        0)
 338                ;; # commit as-is
 339        *)
 340                if test -f "$GIT_DIR/MERGE_HEAD"
 341                then
 342                        refuse_partial "Cannot do a partial commit during a merge."
 343                fi
 344
 345                TMP_INDEX="$GIT_DIR/tmp-index$$"
 346                W=
 347                test -z "$initial_commit" && W=--with-tree=HEAD
 348                commit_only=`git ls-files --error-unmatch $W -- "$@"` || exit
 349
 350                # Build a temporary index and update the real index
 351                # the same way.
 352                if test -z "$initial_commit"
 353                then
 354                        GIT_INDEX_FILE="$THIS_INDEX" \
 355                        git read-tree --index-output="$TMP_INDEX" -i -m HEAD
 356                else
 357                        rm -f "$TMP_INDEX"
 358                fi || exit
 359
 360                printf '%s\n' "$commit_only" |
 361                GIT_INDEX_FILE="$TMP_INDEX" \
 362                git update-index --add --remove --stdin &&
 363
 364                save_index &&
 365                printf '%s\n' "$commit_only" |
 366                (
 367                        GIT_INDEX_FILE="$NEXT_INDEX"
 368                        export GIT_INDEX_FILE
 369                        git update-index --add --remove --stdin
 370                ) || exit
 371                ;;
 372        esac
 373        ;;
 374esac
 375
 376################################################################
 377# If we do as-is commit, the index file will be THIS_INDEX,
 378# otherwise NEXT_INDEX after we make this commit.  We leave
 379# the index as is if we abort.
 380
 381if test -f "$NEXT_INDEX"
 382then
 383        USE_INDEX="$NEXT_INDEX"
 384else
 385        USE_INDEX="$THIS_INDEX"
 386fi
 387
 388case "$status_only" in
 389t)
 390        # This will silently fail in a read-only repository, which is
 391        # what we want.
 392        GIT_INDEX_FILE="$USE_INDEX" git update-index -q --unmerged --refresh
 393        run_status
 394        exit $?
 395        ;;
 396'')
 397        GIT_INDEX_FILE="$USE_INDEX" git update-index -q --refresh || exit
 398        ;;
 399esac
 400
 401################################################################
 402# Grab commit message, write out tree and make commit.
 403
 404if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
 405then
 406    GIT_INDEX_FILE="${TMP_INDEX:-${USE_INDEX}}" "$GIT_DIR"/hooks/pre-commit \
 407    || exit
 408fi
 409
 410if test "$log_message" != ''
 411then
 412        printf '%s\n' "$log_message"
 413elif test "$logfile" != ""
 414then
 415        if test "$logfile" = -
 416        then
 417                test -t 0 &&
 418                echo >&2 "(reading log message from standard input)"
 419                cat
 420        else
 421                cat <"$logfile"
 422        fi
 423elif test "$use_commit" != ""
 424then
 425        encoding=$(git config i18n.commitencoding || echo UTF-8)
 426        git show -s --pretty=raw --encoding="$encoding" "$use_commit" |
 427        sed -e '1,/^$/d' -e 's/^    //'
 428elif test -f "$GIT_DIR/MERGE_MSG"
 429then
 430        cat "$GIT_DIR/MERGE_MSG"
 431elif test -f "$GIT_DIR/SQUASH_MSG"
 432then
 433        cat "$GIT_DIR/SQUASH_MSG"
 434elif test "$templatefile" != ""
 435then
 436        cat "$templatefile"
 437fi | git stripspace >"$GIT_DIR"/COMMIT_EDITMSG
 438
 439case "$signoff" in
 440t)
 441        sign=$(git-var GIT_COMMITTER_IDENT | sed -e '
 442                s/>.*/>/
 443                s/^/Signed-off-by: /
 444                ')
 445        blank_before_signoff=
 446        tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
 447        grep 'Signed-off-by:' >/dev/null || blank_before_signoff='
 448'
 449        tail -n 1 "$GIT_DIR"/COMMIT_EDITMSG |
 450        grep "$sign"$ >/dev/null ||
 451        printf '%s%s\n' "$blank_before_signoff" "$sign" \
 452                >>"$GIT_DIR"/COMMIT_EDITMSG
 453        ;;
 454esac
 455
 456if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
 457        echo "#"
 458        echo "# It looks like you may be committing a MERGE."
 459        echo "# If this is not correct, please remove the file"
 460        printf '%s\n' "#        $GIT_DIR/MERGE_HEAD"
 461        echo "# and try again"
 462        echo "#"
 463fi >>"$GIT_DIR"/COMMIT_EDITMSG
 464
 465# Author
 466if test '' != "$use_commit"
 467then
 468        eval "$(get_author_ident_from_commit "$use_commit")"
 469        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 470fi
 471if test '' != "$force_author"
 472then
 473        GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
 474        GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
 475        test '' != "$GIT_AUTHOR_NAME" &&
 476        test '' != "$GIT_AUTHOR_EMAIL" ||
 477        die "malformed --author parameter"
 478        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
 479fi
 480
 481PARENTS="-p HEAD"
 482if test -z "$initial_commit"
 483then
 484        rloga='commit'
 485        if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 486                rloga='commit (merge)'
 487                PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
 488        elif test -n "$amend"; then
 489                rloga='commit (amend)'
 490                PARENTS=$(git cat-file commit HEAD |
 491                        sed -n -e '/^$/q' -e 's/^parent /-p /p')
 492        fi
 493        current="$(git rev-parse --verify HEAD)"
 494else
 495        if [ -z "$(git ls-files)" ]; then
 496                echo >&2 'nothing to commit (use "git add file1 file2" to include for commit)'
 497                exit 1
 498        fi
 499        PARENTS=""
 500        rloga='commit (initial)'
 501        current=''
 502fi
 503set_reflog_action "$rloga"
 504
 505if test -z "$no_edit"
 506then
 507        {
 508                echo ""
 509                echo "# Please enter the commit message for your changes."
 510                echo "# (Comment lines starting with '#' will not be included)"
 511                test -z "$only_include_assumed" || echo "$only_include_assumed"
 512                run_status
 513        } >>"$GIT_DIR"/COMMIT_EDITMSG
 514else
 515        # we need to check if there is anything to commit
 516        run_status >/dev/null
 517fi
 518if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" ]
 519then
 520        rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 521        use_status_color=t
 522        run_status
 523        exit 1
 524fi
 525
 526case "$no_edit" in
 527'')
 528        git-var GIT_AUTHOR_IDENT > /dev/null  || die
 529        git-var GIT_COMMITTER_IDENT > /dev/null  || die
 530        git_editor "$GIT_DIR/COMMIT_EDITMSG"
 531        ;;
 532esac
 533
 534case "$verify" in
 535t)
 536        if test -x "$GIT_DIR"/hooks/commit-msg
 537        then
 538                "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
 539        fi
 540esac
 541
 542if test -z "$no_edit"
 543then
 544    sed -e '
 545        /^diff --git a\/.*/{
 546            s///
 547            q
 548        }
 549        /^#/d
 550    ' "$GIT_DIR"/COMMIT_EDITMSG
 551else
 552    cat "$GIT_DIR"/COMMIT_EDITMSG
 553fi |
 554git stripspace >"$GIT_DIR"/COMMIT_MSG
 555
 556# Test whether the commit message has any content we didn't supply.
 557have_commitmsg=
 558grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
 559        git stripspace > "$GIT_DIR"/COMMIT_BAREMSG
 560
 561# Is the commit message totally empty?
 562if test -s "$GIT_DIR"/COMMIT_BAREMSG
 563then
 564        if test "$templatefile" != ""
 565        then
 566                # Test whether this is just the unaltered template.
 567                if cnt=`sed -e '/^#/d' < "$templatefile" |
 568                        git stripspace |
 569                        diff "$GIT_DIR"/COMMIT_BAREMSG - |
 570                        wc -l` &&
 571                   test 0 -lt $cnt
 572                then
 573                        have_commitmsg=t
 574                fi
 575        else
 576                # No template, so the content in the commit message must
 577                # have come from the user.
 578                have_commitmsg=t
 579        fi
 580fi
 581
 582rm -f "$GIT_DIR"/COMMIT_BAREMSG
 583
 584if test "$have_commitmsg" = "t"
 585then
 586        if test -z "$TMP_INDEX"
 587        then
 588                tree=$(GIT_INDEX_FILE="$USE_INDEX" git write-tree)
 589        else
 590                tree=$(GIT_INDEX_FILE="$TMP_INDEX" git write-tree) &&
 591                rm -f "$TMP_INDEX"
 592        fi &&
 593        commit=$(git commit-tree $tree $PARENTS <"$GIT_DIR/COMMIT_MSG") &&
 594        rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
 595        git update-ref -m "$GIT_REFLOG_ACTION: $rlogm" HEAD $commit "$current" &&
 596        rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
 597        if test -f "$NEXT_INDEX"
 598        then
 599                mv "$NEXT_INDEX" "$THIS_INDEX"
 600        else
 601                : ;# happy
 602        fi
 603else
 604        echo >&2 "* no commit message?  aborting commit."
 605        false
 606fi
 607ret="$?"
 608rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 609
 610cd_to_toplevel
 611
 612git rerere
 613
 614if test "$ret" = 0
 615then
 616        git gc --auto
 617        if test -x "$GIT_DIR"/hooks/post-commit
 618        then
 619                "$GIT_DIR"/hooks/post-commit
 620        fi
 621        if test -z "$quiet"
 622        then
 623                commit=`git diff-tree --always --shortstat --pretty="format:%h: %s"\
 624                       --summary --root HEAD --`
 625                echo "Created${initial_commit:+ initial} commit $commit"
 626        fi
 627fi
 628
 629exit "$ret"